/*
 * V8 related stuff, to do with setting up a data connection.
 * for more background information read "ITU-T recommedation V.8"
 *
 * Copyright 1999 R.J.M. Close
 *
 * Can be distributed under GPL
 */

#include "dp_v8bis.h"


// CI (call indicator) initialisation stuff etc.
void v8_ci_ans_init (void)
{
 printf("v8_ci_ans_init: warning not yet implemented!\n");
// var_2		 = byte	ptr -2
// var_1		 = byte	ptr -1
  /*
000_v8_ci_ans_init_0		 push	 ebp
0002FC95		 mov	 ebp, esp
0002FC97		 push	 ecx
0002FC98		 push	 ebx
0002FC99		 call	 sub__dp_modem_idle_cmd_0
0002FC9E		 mov	 al, byte_59E9A
0002FCA3		 mov	 bl, byte_59E85
0002FCA9		 and	 dword__v8_ci_seq_state, 0
0002FCB0		 and	 byte_59E9A, 0
0002FCB7		 mov	 [ebp+var_1], al
0002FCBA		 mov	 al, byte ptr dword__x_modem_mode
0002FCBF		 and	 dword__x_modem_mode, 0
0002FCC6		 mov	 [ebp+var_2], al
0002FCC9		 mov	 byte_59E85, 3
0002FCD0		 call	 sub__dp_update_modem_options_0
0002FCD5		 mov	 al, [ebp+var_1]
0002FCD8		 push	 39h
0002FCDA		 mov	 byte_59E9A, al
0002FCDF		 mov	 byte_59E85, bl
0002FCE5		 movzx	 eax, [ebp+var_2]
0002FCE9		 mov	 dword__x_modem_mode, eax
0002FCEE		 call	 sub__dp_read_dsp_ram_4
0002FCF3		 or	 ah, 20h
0002FCF6		 push	 eax
0002FCF7		 push	 39h
0002FCF9		 call	 sub__dp_write_dsp_ram_8
0002FCFE		 push	 0
0002FD00		 push	 0
0002FD02		 push	 0Eh
0002FD04		 mov	 dword__x_line_rate, 2
0002FD0E		 call	 sub__dp_modem_command_12
0002FD13		 pop	 ebx
0002FD14		 leave	 

*/
}

// Not to bothered now since is required for the answer DCE. 
void v8_ci_sequence_detected (void)
{
/*
var_C		 = byte	ptr -0Ch
var_B		 = byte	ptr -0Bh
var_A		 = byte	ptr -0Ah
var_9		 = byte	ptr -9
var_8		 = byte	ptr -8
var_7		 = byte	ptr -7
var_4		 = dword ptr -4

000_v8_ci_sequence_detected_0		 push	 ebp
0002FD17		 mov	 ebp, esp
0002FD19		 sub	 esp, 0Ch
0002FD1C		 lea	 eax, [ebp+var_4]
0002FD1F		 push	 eax
0002FD20		 push	 1
0002FD22		 call	 sub__io_read_dce_fifo_8
0002FD27		 test	 al, al
0002FD29		 jz	 loc_2FE63
0002FD2F		 mov	 eax, [ebp+var_4]
0002FD32		 mov	 ecx, dword__v8_ci_seq_state
0002FD38		 and	 eax, 0FFh
0002FD3D		 dec	 ecx
0002FD3E		 mov	 [ebp+var_4], eax
0002FD41		 jz	 loc_2FE19
0002FD47		 dec	 ecx
0002FD48		 jz	 loc_2FE08
0002FD4E		 dec	 ecx
0002FD4F		 jz	 short loc_2FD69
0002FD51		 test	 ax, ax
0002FD54		 jnz	 loc_2FE63
0002FD5A		 mov	 dword__v8_ci_seq_state, 1
0002FD64		 jmp	 loc_2FE63

0002FD69 loc_2FD69:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+39j
0002FD69		 xor	 ecx, ecx
0002FD6B		 cmp	 ax, word__rx_ci_octet
0002FD72		 mov	 dword__v8_ci_seq_state, ecx
0002FD78		 jnz	 loc_2FE63
0002FD7E		 cmp	 byte_59EB3, 5
0002FD85		 jnz	 short loc_2FDF9
0002FD87		 push	 58h
0002FD89		 call	 nullsub_2
0002FD8E		 call	 sub__dp_a8_msg_0
0002FD93		 movzx	 eax, word__rx_ci_octet
0002FD9A		 cdq	 
0002FD9B		 mov	 ecx, 100h
0002FDA0		 push	 10h
0002FDA2		 idiv	 ecx
0002FDA4		 pop	 ecx
0002FDA5		 mov	 [ebp+var_C], 49h
0002FDA9		 mov	 [ebp+var_B], 3Ah
0002FDAD		 mov	 eax, edx
0002FDAF		 cdq	 
0002FDB0		 idiv	 ecx
0002FDB2		 push	 eax
0002FDB3		 call	 sub__decdigit_to_hexchar_4
0002FDB8		 mov	 [ebp+var_A], al
0002FDBB		 push	 10h
0002FDBD		 movzx	 eax, word__rx_ci_octet
0002FDC4		 cdq	 
0002FDC5		 pop	 ecx
0002FDC6		 idiv	 ecx
0002FDC8		 push	 edx
0002FDC9		 call	 sub__decdigit_to_hexchar_4
0002FDCE		 mov	 [ebp+var_9], al
0002FDD1		 mov	 al, byte_59E63
0002FDD6		 mov	 [ebp+var_8], al
0002FDD9		 mov	 al, byte_59E64
0002FDDE		 mov	 [ebp+var_7], al
0002FDE1		 lea	 eax, [ebp+var_C]
0002FDE4		 push	 6
0002FDE6		 push	 eax
0002FDE7		 push	 3
0002FDE9		 push	 21h
0002FDEB		 call	 sub__x_send_mail_16
0002FDF0		 push	 2Eh
0002FDF2		 call	 nullsub_2
0002FDF7		 jmp	 short loc_2FE04

0002FDF9 loc_2FDF9:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+6Fj
0002FDF9		 push	 ecx
0002FDFA		 push	 ecx
0002FDFB		 push	 2
0002FDFD		 push	 14h
0002FDFF		 call	 sub__x_send_mail_16
0002FE04 
0002FE04 loc_2FE04:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+E1j
0002FE04		 mov	 al, 1
0002FE06		 leave	 
0002FE07		 retn	 

0002FE08 loc_2FE08:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+32j
0002FE08		 test	 ax, ax
0002FE0B		 jnz	 short loc_2FE63
0002FE0D		 mov	 dword__v8_ci_seq_state, 3
0002FE17		 jmp	 short loc_2FE63

0002FE19 loc_2FE19:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+2Bj
0002FE19		 cmp	 byte_59EB3, 5
0002FE20		 jnz	 short loc_2FE3C
0002FE22		 test	 al, 1
0002FE24		 jz	 short loc_2FE63
0002FE26		 test	 al, 1Eh
0002FE28		 jnz	 short loc_2FE63
0002FE2A		 mov	 word__rx_ci_octet, ax
0002FE30		 mov	 dword__v8_ci_seq_state, 2
0002FE3A		 jmp	 short loc_2FE63

0002FE3C loc_2FE3C:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+10Aj
0002FE3C		 movzx	 cx, byte_59EB4
0002FE44		 cmp	 ax, cx
0002FE47		 jnz	 short loc_2FE5C
0002FE49		 mov	 dword__v8_ci_seq_state, 2
0002FE53		 mov	 word__rx_ci_octet, cx
0002FE5A		 jmp	 short loc_2FE63

0002FE5C loc_2FE5C:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+131j
0002FE5C		 and	 dword__v8_ci_seq_state, 0
0002FE63 
0002FE63 loc_2FE63:				 ; CODE	XREF: sub__v8_ci_sequence_detected_0+13j
0002FE63					 ; sub__v8_ci_sequence_detected_0+3Ej ...
0002FE63		 xor	 al, al
0002FE66		 retn	 
*/
}

// This needs sorting!
// Called by dp_calling_tone_cmd (see dp_call.c)
// My ISP sends an answer tone without the caller DCE sending a CI
// so maybe I don't need this?
void v8_ci_orig (void)
{
   unsigned char al, bl, cl;
   unsigned int edx, esi;

   dp_modem_idle_cmd();
   al = S(0x3A);
   bl = S_dial_line_rate;
   S(0x3A) = 0;
   // mov	 [ebp-1], al  save for later!
   S_dial_line_rate = 3;
   dp_update_modem_options();
   // 	 mov	 al, [ebp-1] retrieve al.
   // Restore dial line rate.
   S_dial_line_rate = bl;
   S(0x3A) = al;

   io_init_dce_tx_fifo();
   dp_write_dsp_ram(0x39, (dp_read_dsp_ram (0x39) | 0x20));

   x_line_rate = 2;
   dp_modem_command(14, 1, 0);

   cl = S(0x54);
   // push 5 ?
   al = cl;
   edx = al;
   //word ptr [ebp-2Ch] = 20FFh
   // is this var_2C ?
   // Lost the plot a bit here!
/*

0002FEE4		 shl	 edx, 5
0002FEE7		 or	 dx, 2008h
0002FEEC		 mov	 word ptr [ebp-2Ah], 2003h // var_2A ??
0002FEF2		 mov	 [ebp-28h], dx
0002FEF6		 mov	 dl, cl
0002FEF8		 shr	 dl, 3
0002FEFB		 movzx	 dx, dl
0002FEFF		 or	 dx, 20E0h
0002FF04		 mov	 word ptr [ebp-24h], 20FFh
0002FF0A		 mov	 [ebp-26h], dx
0002FF0E		 mov	 edx, eax
0002FF10		 shl	 edx, 3
0002FF13		 or	 dx, 2002h
0002FF18		 mov	 word ptr [ebp-22h], 2000h
0002FF1E		 mov	 [ebp-20h], dx
0002FF22		 mov	 dl, cl
0002FF24		 shr	 dl, 5
0002FF27		 movzx	 dx, dl
0002FF2B		 or	 dx, 20F8h
0002FF30		 mov	 word ptr [ebp-1Ch], 203Fh
0002FF36		 mov	 [ebp-1Eh], dx
0002FF3A		 mov	 edx, eax
0002FF3C		 or	 dh, 10h
0002FF3F		 mov	 word ptr [ebp-1Ah], 2080h
0002FF45		 shl	 edx, 1
0002FF47		 mov	 [ebp-18h], dx
0002FF4B		 mov	 dl, cl
0002FF4D		 shl	 eax, 7
0002FF50		 shr	 dl, 7
0002FF53		 or	 ax, 2020h
0002FF57		 mov	 word ptr [ebp-14h], 200Fh
0002FF5D		 shr	 cl, 1
0002FF5F		 movzx	 dx, dl
0002FF63		 mov	 [ebp-12h], ax
0002FF67		 or	 dx, 20FEh
0002FF6C		 movzx	 ax, cl
0002FF70		 or	 ax, 2080h
0002FF74		 mov	 [ebp-16h], dx
0002FF78		 mov	 [ebp-10h], ax
*/

   // pop esi
   esi = 5;
   while (esi > 0) {
     int eax = 0x20FF;   //[ebp - 0x2C];
     io_write_dce_fifo(15, eax);
     esi--;
   }

}

// Set up V8 tone detection.
void dp_detect_v8_tones_cmd (void)
{
   dp_modem_idle_cmd();
   dp_write_dsp_ram(0x26, 0x28);
   dp_write_dsp_ram(0x20, 0x20F1);
   dp_write_dsp_ram(0x21, 0x29F9);
   dp_write_dsp_ram(0x1C, 0x24B5);
   dp_write_dsp_ram(0x1D, 0x1B0C);
   dp_write_dsp_ram(0x1E, 0xE453);
   dp_write_dsp_ram(0x1F, 0xCB2E);
   dp_modem_command(8, 6, 0);
   v8_ci_tone_state = 0;
}

bool dp_v8_tone_detected (void)
{
  unsigned int eax;

  if (S(0x53) != 5) return false;  // Can only be set by at_v8_cmd!

  eax = v8_ci_tone_state;
  eax--;
  if (eax == 0) goto loc_30076;
  eax--;
  if (eax == 0) goto loc_30052;
  eax--;
  if (eax == 0) goto loc_3003D;

  eax = dp_read_dsp_ram(0x28);
  if (eax != 0x20) return false;

  // Set tone state and reset tone timer.
  v8_ci_tone_state = 1;
  ci_tone_timer = x_current_time();
  return false;

loc_30076: // Tone state == 1.
  eax = dp_read_dsp_ram(0x28);
  if (eax != 0x10) goto  loc_3009A;
  // Transition to state 2, reseting timer.
  ci_tone_timer = x_current_time();
  v8_ci_tone_state = 2;
  return false;

loc_30052: // Tone state == 2. 
  eax = dp_read_dsp_ram(0x28);
  if (eax != 0x20) goto loc_3009A;
  // Transition to state 3, reseting timer.
  ci_tone_timer = x_current_time();
  v8_ci_tone_state = 3;
  return false;

loc_3003D: // Tone state == 3. 
  eax = dp_read_dsp_ram(0x28);
  if (eax != 0x10) goto  loc_3009A;
  // Tone detected!
  v8_ci_tone_state = 0;
  return true;

loc_3009A:
  if (x_elapsed_time(ci_tone_timer) > 100) 
	// If timed out then reset tone state.
	v8_ci_tone_state = 0;
  return false;
}


// Initialise V8bis state, called by dp_periodic_task.
void v8bis_init(void)
{
  int i;

  v8bis_state = 0;

  for (i=0; i<=5; i++) {
    v8bis_ptr[i] = 0;
    }
  v8bis_ptr[0x170] = 0;
  v8bis_ptr[0x171] = 0;
  for (i=0x178; i<=0x18D; i++) {
    v8bis_ptr[i] = 0;
    }
  v8bis_ptr[0x193] = 0;

  lapm_receive_frame[0] = 0;
  lapm_receive_frame[2] = 0;
  lapm_receive_frame[3] = 0;

  dp_write_dsp_ram(0x39, 0);
}

void v8bis_reset(void)
{
  unsigned short ax;

  dp_write_dsp_ram(0x39, 0);
  if (dp_state != 0x3A) goto loc_303A7;

  if (v8bis_ptr[0x184] != 0) goto loc_303A7;

  if (x_modem_mode == 3)
    x_send_mail (0x51, 1, 0, 0);

  v8bis_app_reset1();
  v8bis_ptr[0x192] = 0;
  return;

loc_303A7:
  if (x_modem_mode == 3) {
	// Check byte order!!
	ax = x_current_time();
    v8bis_ptr[0x178] = ax & 0xff; // lsb
    v8bis_ptr[0x179] = ax / 256;  // msb
    v8bis_ptr[0x17A] = ax & 0xff; // lsb
    v8bis_ptr[0x17B] = ax / 256;  // msb

    lapm_receive_frame[0] = 0;
    lapm_receive_frame[2] = 0;
    lapm_receive_frame[3] = 0;

    v8bis_ptr[0] = 0;

    v8bis_state = 0x15;
    v8bis_ptr[4] = 0;
    v8bis_ptr[5] = 0;
    v8bis_ptr[0x170] = 0;
    return;
  }
  else {
    v8bis_state = 0x15;
    v8bis_ptr[4] = 0;
    v8bis_ptr[5] = 0;

    lapm_receive_frame[0] = 0;
    lapm_receive_frame[2] = 0;
    lapm_receive_frame[3] = 0;

    v8bis_ptr[0] = 0;
    v8bis_ptr[2] = 0;
    v8bis_ptr[3] = 0;

    v8bis_ptr[0x178] = 0;
    v8bis_ptr[0x179] = 0;
    v8bis_ptr[0x17a] = 0;
    v8bis_ptr[0x17b] = 0;
    v8bis_ptr[0x17e] = 0;
    v8bis_ptr[0x17f] = 0;
    v8bis_ptr[0x180] = 0;
    v8bis_ptr[0x181] = 0;
    v8bis_ptr[0x182] = 0;
    v8bis_ptr[0x183] = 0;
    v8bis_ptr[0x185] = 0;
	return;
  }
}

void v8bis_clear_dsp_ram(void)
{
  int i;
  for (i = 0x5EB; i <= 0x5F0; i++)
    dp_write_dsp_ram (i, 0);
  for (i = 0x828; i <= 0x82D; i++)
    dp_write_dsp_ram (i, 0);
}

// This is the 568 version of the code, I also
// used the 568 version of DSP code.
void dp_download_V8bis(void)
{
   v8bis_clear_dsp_ram();
   dp_modem_command(0x13, 0, 0);
   if (x_dsp_mars3) {
     dp_download_dsp (wDsp_V8BIS, 0x168);   
     dp_download_dsp (wDsp_V8BIST, 0x5a);  
     // Don't bother with fax for now. 
     //dp_download_dsp (wDspFax_apofax5, 0x6f3);   
   }
   else
     dp_download_dsp (wDspV8bis, 0xa84);   
   dp_modem_command(0x13, 0, 0);
}

void v8bis_v21_startup (bool arg1)
{
  unsigned char al;

  dp_modem_idle_cmd ();
  io_init_dce_tx_fifo ();
  io_init_dce_rx_fifo ();
  dp_download_V8bis ();
  dp_write_dsp_ram (0x80d, 0);
  dp_write_dsp_ram (0x01, 0);
  dp_write_dsp_ram (0x02, 0);
  dp_write_dsp_ram (0x0c, 0);
  dp_write_dsp_ram (0x39, 0x2800);
  dp_write_dsp_ram (0x48, 0x07d0);
  dp_write_dsp_ram (0x37, 0x0028);
  dp_transmit_level (H_transmit_level_ndB - 2);
  dp_write_dsp_ram (0x02, 0x1000);
  dp_hdlc_mode();

  dp_regread (0xb0);
  dp_dsp_data_in_progress = false;
  v8bis_ptr[0x192] = 1;

  if (arg1 == false) {
    if (v8bis_ptr[0x191] == 1)
       al = 3;
    else
       al = 0;
    }
  else { 
    if (v8bis_ptr[0x191] == 1)
       al = 2;
    else
       al = 1;
    }
  x_line_rate = 2;
  dp_modem_command_long (0x1B, 0xCD, 0x14, al, 0); 
  x_modem_state = 6;
  lapm_receive_frame[0] = 0;
  lapm_receive_frame[2] = 0;
  lapm_receive_frame[3] = 0;
  v8bis_ptr[4] = 0;
  v8bis_ptr[5] = 0;
}
void dp_v8bis_v21_startup (bool arg1, bool arg2)
{
  unsigned char al;

  dp_modem_idle_cmd ();
  io_init_dce_tx_fifo ();
  io_init_dce_rx_fifo ();
  dp_download_V8bis ();
  dp_write_dsp_ram (0x80d, 0);
  dp_write_dsp_ram (0x01, 0);
  dp_write_dsp_ram (0x02, 0);
  dp_write_dsp_ram (0x0c, 0);
  dp_write_dsp_ram (0x39, 0x2800);
  dp_write_dsp_ram (0x48, 0x07d0);
  dp_write_dsp_ram (0x37, 0x0028);

  dp_transmit_level (10);
  dp_write_dsp_ram (0x02, 0x1000);
  dp_regread (0xb0);
  dp_dsp_data_in_progress = false;
  if (!arg2)
    {
      dp_async_8bit_mode ();
      x_line_rate = 2;
	  if (arg1) al = 3; else al = 0;
      dp_modem_command_long (0x1b, 0xcd, 0x14, al, 0);
    }
  else
    {
      dp_hdlc_mode ();
      x_line_rate = 2;
	  if (arg1) al = 2; else al = 1;
      dp_modem_command_long (0x1b, 0xcd, 0x14, al, 0);
    }
  // Reset lapm stuff.
  lapm_receive_frame[2] = 0;
  lapm_receive_frame[3] = 0;

}


void dp_v8bis_voice_ans_rx_setup(void)
{
  dp_v8bis_v21_startup(true, true);
}

void v8bis_app_reset(void)
{
  v8bis_app_reset1();
  v8bis_ptr[0x190] = 0;
  v8bis_ptr[0x191] = 0;
  v8bis_ptr[0x170] = 0;
}

void v8bis_app_reset1(void)
{
  v8bis_ptr[0x18E] = 0;
  v8bis_ptr[0x18F] = 0;
  v8bis_ptr[0] = 0;
  v8bis_ptr[1] = 0;
  v8bis_ptr[2] = 0;
  v8bis_ptr[3] = 0;
  v8bis_ptr[0x17E] = 0;
  v8bis_ptr[0x17F] = 0;
  v8bis_ptr[0x180] = 0;
  v8bis_ptr[0x181] = 0;
  v8bis_ptr[0x182] = 0;
  v8bis_ptr[0x183] = 0;
  v8bis_ptr[0x178] = 0;
  v8bis_ptr[0x179] = 0;
  v8bis_ptr[0x17A] = 0;
  v8bis_ptr[0x17B] = 0;
  v8bis_ptr[0x184] = 0;

  lapm_receive_frame[0] = 0;
  lapm_receive_frame[2] = 0;
  lapm_receive_frame[3] = 0;
 
  v8bis_ptr[0x4] = 0;
  v8bis_ptr[0x5] = 0;

  dp_write_dsp_ram(0x39, 0);

  v8bis_ptr[0x185] = 0;
  v8bis_ptr[0x18C] = 0;
  v8bis_ptr[0x18D] = 0;
  v8bis_ptr[0x186] = 0;
  v8bis_ptr[0x187] = 0;
  v8bis_ptr[0x188] = 0;
  v8bis_ptr[0x189] = 0;
  v8bis_ptr[0x18A] = 0;
  v8bis_ptr[0x18B] = 0;
  v8bis_ptr[0x193] = 0;

  v8bis_clear_dsp_ram();

  if ((S(0x6a) == 1) && (S(0x38) == 10))
	S(0x38) = 6;
}

bool dp_v8bis_ans_background(void)
{
  printf("dp_v8bis_ans_background: Warning not yet implemented!\n");
  return false;
}
