/*
 *
 *	Stuff that handles V8 stuff.
 *
 *	Copyright (c) 2000 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef LT_V8BIS_H

#define LT_V8BIS_H 1

#include "stdbool.h"
#include "modem_globals.h"
#include "dp_vpcm.h"
#include "lapm.h"
#include "control.h"

void v8_ci_orig (void);

void dp_detect_v8_tones_cmd (void);

bool dp_v8_tone_detected (void);

void v8bis_init(void);
void v8bis_reset(void);

void v8bis_clear_dsp_ram(void);
void dp_download_V8bis(void);

void v8bis_v21_startup (bool arg1);
void dp_v8bis_v21_startup (bool arg1, bool arg2);

void dp_v8bis_voice_ans_rx_setup(void);

void v8bis_app_reset(void);
void v8bis_app_reset1(void);

// Dummy.
bool dp_v8bis_ans_background(void);

// Variables.
unsigned int v8_ci_tone_state;
unsigned short ci_tone_timer;
unsigned char v8bis_ptr[0x200];

// These is set up in dsp.c
extern unsigned char wDspV8bis[];
extern unsigned char wDsp_V8BIS[];   
extern unsigned char wDsp_V8BIST[];   
extern unsigned char wDspFax_apofax5[];   


#endif

