#!/bin/sh
# This script is done by Mei (m_e_i_69@hotmail.com 
# angelo.difilippo@tiscalinet.it). If you are sure your modem is a
# Lucent isa pnp modem and this script doesn't detect it please send me
# your pnpdump output.

# I must find the isapnp Vendor Id and the serial number of the modem
READPORT=$(pnpdump | grep READPORT)
MODEM=$(pnpdump | \
	grep "NAME" | \
	grep "LT Win Modem" | \
	sed 's/ (NAME "//' | \
	sed s/[[][[:graph:][:alnum:][:space:]]*//)

if [ $MODEM!= ]; then
	BOARD=$(pnpdump | grep -c Board)
	
	QUERY=$(echo $READPORT
		echo '(CSN '$BOARD')'
		echo '(IDENTIFY *)'
		echo '(VERBOSITY 3)' 
		echo '(CONFIGURE '$MODEM' (LD 0'
		echo '(INT 0 (PEEK))'
		echo '(IO 1 (PEEK))))')

	INT0=$(echo $QUERY | \
		isapnp - | \
		grep '(INT 0)' | \
		sed 's/[[:alnum:][:graph:][:space:]]*,[[:space:]](//' | \
		sed 's/,[[:digit:]]*)//') 

	IO1=$(echo $QUERY | \
		isapnp - | \
		grep '(IO  1)' | \
		sed 's/[[:alnum:][:graph:][:space:]]*is[[:space:]]//' | \
		sed 's/,[[:space:][:graph:][:alnum:]]*//') 

	if [ $INT0!= ]; then
		if [ $I01!= ]; then
			echo $INT0 
			echo $IO1
# Here we must put the command with the parameters for ltmodem;
# something like ltmodem --irq $INT0 --io $IO1
# Now it only writes the interrupt value and the starting io
# address
		else
			echo IO address not found
		fi
	else
		echo Interrupt for the modem not found
	fi
else
	echo Modem isa not found
fi
