/*
 *
 *	Stuff that does mnp (whatever that is!).
 *
 *	Copyright (c) 1999 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef LT_MNP_H

#define LT_MNP_H 1

#include "modem_globals.h"
#include "portIO.h"
#include "io_dce.h"

// Local mnp vars.
unsigned int mnp_rx_octet_state;

unsigned char mnp_vs, mnp_va, mnp_vr, mnp_ns;
unsigned char mnp_vsa, mnp_vrb, mnp_vsb, mnp_k;
unsigned short mnp_max_info_octects;

unsigned char mnp_ns, mnp_nsa, mnp_nra;
unsigned char mnp_vra, mnp_rk, mnp_nk, mnp_sk;

unsigned char mnp_framing_mode, mnp_data_opt_flag;
unsigned char mnp_stream_opt_flag, mnp_fixed_field_opt_flag;
unsigned char mnp_data_compression, mnp_attention_type;
unsigned char mnp_disconnect_code, mnp_user_disconnect_code;
unsigned char mnp_retransmit, mnp_first_lt_flag, mnp_last_ack;
unsigned char mnp_seq_recover_flag, mnp_negotiated_mode;
unsigned char mnp_rx_data_opt_flag, mnp_rx_stream_opt_flag;
unsigned char mnp_rx_fixed_field_opt_flag, mnp_rx_data_compression;
unsigned char mnp_rx_disconnect_code, mnp_rx_user_disconnect_code;

unsigned int mnp_state;

// mnp routines.
void mnp_init_variables(void);
unsigned char mnp_rx_frame_type(void);
void mnp_build_lr_frame(void);
void mnp_build_control_frame(unsigned char arg1);

void mnp_tx_octet_frame(void);
void mnp_rx_data(void);

unsigned char mnp_negotiate_params(void);

unsigned int mnp_background(void);

#endif
