/*
 *
 *	Stuff that handles dce I/O stuff.
 *
 *	Copyright (c) 1999 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

#ifndef LT_IO_DCE

#define LT_IO_DCE 1

#include "modem_globals.h"
#include "task.h"

unsigned char io_dce_tx_fifo_empty(void);
void io_init_dce_tx_fifo(void);
void io_init_dce_rx_fifo(void);
unsigned int io_get_dce_rx_count(void);

void io_write_dce_fifo (unsigned int count, unsigned short wData);

void io_start_dce_transmit(void);

#endif
