#ifndef ISA_UTILS_H

#define ISA_UTILS_H 1
/*
 *
 *  ISA specific stuff.
 *
 *  Copyright (c) 1999 Richard J.M. Close
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "stdbool.h"
#include "modem_globals.h"
#include "config.h"


/******************************************************************************
*
* ISA utilities.
*
*******************************************************************************/

bool modem_found;			// Boolean: modem has been found.

/* Array to hold IO addresses and their width (in bytes). */
unsigned int io_address[6];
unsigned int io_length[6];

/* The number of I/O ports found, = length of io_address. */
unsigned int io_cnt;

void init_isa(void);
void cleanup_isa (void);
unsigned int get_isamodem_irq (void);
void show_isamodem(void);
//int find_modem(void);
void show_isahex_dump(void);

void __attribute__((noreturn)) die(char *msg, ...);

#endif
