//
// Header file for phone program.
//

#define VERSION "0.1.0"

/* Max 512 */

#define BUFSIZE 16

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <limits.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <stdio.h>
#include <signal.h>
#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <assert.h>

//#include "/usr/src/esound-0.2.8/esd.h"
#include "/usr/include/esd.h"

int com_dial(char *s);
int com_help(char *s);
int com_quit(char *s);
int com_record(char *s);
int com_playback(char *s);
int com_stop(char *s);

static void err(char *) __attribute__((noreturn));
char *call_who = NULL;
char *sound_device = "/dev/dsp";

static void clear_line(void);

#define mprintf(a...) do { clear_line(); printf(a); rl_forced_update_display(); } while(0)
